﻿
namespace WingRtmpService
{
     public enum ChannelCategory
    {
        DeskChannel,
        TerminalChannel,
        CameraChannel,
        TerminalTestChannel,
        NoneChannel
    }

    public class ChannelData 
    {        
        public string Id { get; }
        public ChannelCategory Category { get; set; }
        public string UpLoadUrl { get; }

        public string DownLoadUrl { get; }

        public string HttpUrl { get; }

        public string HlsUrl { get; }
        public int Height { get; set; }

        public int Width { get; set; }
        
        public bool IsActive { get; set; }
        public bool IsDisposing { get ; set ; }

        public string UserId { get; set; }
        
        public ChannelData()
        {
            
        }

        public ChannelData(string id, string upLoadUrl, string downLoadUrl, ChannelCategory category, string httpUrl = "", string hlsUrl = "")
        {
            Id = id;
            UpLoadUrl = upLoadUrl;
            DownLoadUrl = downLoadUrl;
            Category = category;
            HttpUrl = httpUrl;
            HlsUrl = hlsUrl;
        }

        public ChannelData(string id, string upLoadUrl, string downLoadUrl, string httpUrl = "", string hlsUrl = "")
        {
            Id = id;
            UpLoadUrl = upLoadUrl;
            DownLoadUrl = downLoadUrl;
            HttpUrl = httpUrl;
            HlsUrl = hlsUrl;
        }

        public string ToString()
        {
            return $"{Category} Cid：{Id} - UpLoadUrl：{UpLoadUrl} - DownLoadUrl：{DownLoadUrl} - IsActive:{IsActive}";
        }

        public void Dispose()
        {
            
        }       
    }
}
