﻿using System.Security.Cryptography;
using System.Text;

namespace WingRtmpService.ChannelManagers.Netease.Helper
{
    public class CheckSumBuilder
    {
        private static readonly char[] HexDigits = { '0', '1', '2', '3', '4', '5',
            '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };

        public static string GetCheckSum(string appSecret, string nonce, string curTime)
        {
            byte[] data = Encoding.Default.GetBytes(appSecret + nonce + curTime);
            var formattedText = GetFormattedText(data);
            using (SHA1 sha = new SHA1CryptoServiceProvider())
            {
                var result = sha.ComputeHash(data);
                var checkSumFormattedText = GetFormattedText(result);
                return checkSumFormattedText;
            }
        }

        private static string GetFormattedText(byte[] bytes)
        {
            var len = bytes.Length;
            var buf = new StringBuilder(len * 2);
            for (int j = 0; j < len; j++)
            {
                buf.Append(HexDigits[(bytes[j] >> 4) & 0x0f]);
                buf.Append(HexDigits[bytes[j] & 0x0f]);
            }
            return buf.ToString();
        }
    }
}
