﻿using System;
using System.Collections;

namespace WingRtmpService.EmbeddedRtmpServer.IO.AMF3.AMFWriters
{
    class Amf3VectorWriter<T> : IAmfItemWriter
    {
        private readonly Amf3TypeMarkers _typeMarker;
        private readonly Action<AmfWriter, IList> _writer;

        public Amf3VectorWriter(Amf3TypeMarkers typeMarker, Action<AmfWriter, IList> writer)
        {
            _typeMarker = typeMarker;
            _writer = writer;
        }

        public void WriteData(AmfWriter writer, object obj)
        {
            writer.WriteMarker(this._typeMarker);
            _writer(writer, obj as IList);
        }
    }
}