﻿using System;
using System.Text;
using WingServerCommon.Log;

namespace WingRtmpService.EmbeddedRtmpServer.Log
{
    class DefaultLogEngine : LogEngine
    {
        public override void Write(LogLevel level, string msg)
        {
            try
            {
                var message = msg;
                if (level == LogLevel.Error)
                {
                    WingServerCommon.Log.Logger.WriteLineError(message);
                }
                else if (level == LogLevel.Warn)
                {
                    WingServerCommon.Log.Logger.WriteLineWarn(message);
                }
                else if (level == LogLevel.Info)
                {
                    WingServerCommon.Log.Logger.WriteLineInfo(message);
                }
                else if (level == LogLevel.Verbose)
                {
                    WingServerCommon.Log.Logger.WriteLineVerbose(message);
                }
                else if (level == LogLevel.Debug)
                {
                    WingServerCommon.Log.Logger.WriteLineDebug(message);
                }
            }
            catch (Exception)
            {
                // There is exception during writing log, so just ignore
            }
        }

        public override void Dispose()
        {
            //
        }
    }
}
