﻿using System;

namespace WingRtmpService.EmbeddedRtmpServer.Log
{

    /// <summary>
    /// The log engine which provider the abilaity to Write log into one file or server.
    /// </summary>
    public abstract class LogEngine: IDisposable
    {
        /// <summary>
        /// Write the log
        /// </summary>
        /// <param name="level">Log's level see <see cref="LogLevel"/></param>
        /// <param name="msg">The message to write</param>
        public abstract void Write(LogLevel level, string msg);

        public virtual void Dispose()
        {
            //Nothing.
        }
    }

}
