﻿using System;

namespace WingRtmpService.EmbeddedRtmpServer.Log
{
    public class LogMessage
    {
        //Gets the owner of this log.
        public string Owner { get; }

        /// <summary>
        /// Gets the time of this log.
        /// </summary>
        public DateTime Time { get; }

        /// <summary>
        /// Gets the <see cref="LogLevel"/> of this log.
        /// </summary>
        public LogLevel Level { get; }

        /// <summary>
        /// Gets the content of this log.
        /// </summary>
        public string Message { get; }

        public LogMessage(string owner, DateTime time, LogLevel level, string message)
        {
            Owner = owner;
            Time = time;
            Level = level;
            Message = message;
        }
    }
}
