﻿namespace WingRtmpService.EmbeddedRtmpServer.Log
{
    public class Logger
    {
        private static LogEngine _logEngine;

        public static bool Debug { get; set; }

        static Logger()
        {
            _logEngine = new DefaultLogEngine();
        }

        public static void RegisterEngine(LogEngine logEngine)
        {
            _logEngine = logEngine;
        }

        public static void WriteLineInfo(string msg)
        {
            _logEngine?.Write(LogLevel.Info,msg);
        }

        public static void WriteLineWarn(string msg)
        {
            _logEngine?.Write(LogLevel.Warn,msg);
        }

        public static void WriteLineError(string msg)
        {
            _logEngine?.Write(LogLevel.Error,msg);
        }

        public static void WriteLineVerbose(string msg)
        {
#if DEBUG
            _logEngine?.Write(LogLevel.Verbose,msg);
#endif
        }

        public static void WriteLineDebug(string msg)
        {
#if DEBUG
            _logEngine?.Write(LogLevel.Debug,msg);
#endif
        }
    }
}
