﻿using WingRtmpService.EmbeddedRtmpServer.Net;

namespace WingRtmpService.EmbeddedRtmpServer.Messaging.Events
{
    class ByteData : RtmpEvent
    {
        public byte[] Data { get; }

        protected ByteData(byte[] data, MessageType messageType) : base(messageType)
        {
            Data = data;
        }
    }

    class AudioData : ByteData
    {
        public AudioData(byte[] data) : base(data, MessageType.Audio)
        {
        }
    }

    class VideoData : ByteData
    {
        public bool IsKeyFrame { get; }

        public VideoData(byte[] data) : base(data, MessageType.Video)
        {
            //TODO I don't know why
            IsKeyFrame = data[0] == 0x17;
        }
    }
}
