﻿using System;
using System.Collections.Generic;

namespace WingRtmpService.EmbeddedRtmpServer.Net
{
    class IdGenerator
    {
        private readonly Random _random = new Random();
        private readonly List<ushort> _allocatedIds = new List<ushort>();

        private ushort GetUniqueIdOfList(IList<ushort> list, int minValue = -1, int maxValue = -1)
        {
            ushort id;
            do
            {
                if (minValue != -1 && maxValue != -1)
                {
                    id = (ushort)_random.Next(minValue, maxValue);
                }
                else
                {
                    id = (ushort)_random.Next();
                }
            } while (list.IndexOf(id) != -1);
            return id;
        }

        public ushort GetUniqueId(int min = -1, int max = -1)
        {
            lock (_allocatedIds)
            {
                return GetUniqueIdOfList(_allocatedIds, min, max);
            }
        }
    }
}
