﻿using System;
using WingRtmpService.EmbeddedRtmpServer.Messaging;

namespace WingRtmpService.EmbeddedRtmpServer.Net
{
    class RtmpPacket
    {
        public RtmpHeader Header { get; set; }

        public RtmpEvent Body { get; set; }

        public byte[] Buffer { get; }

        public int Length { get; }

        public int CurrentLength { get; private set; }

        public bool IsComplete => Length == CurrentLength;

        public RtmpPacket(RtmpHeader header)
        {
            Header = header;
            Length = header.PacketLength;
            Buffer = new byte[Length];
        }

        public RtmpPacket(RtmpHeader header, RtmpEvent body) : this(header)
        {
            Body = body;
            Length = header.PacketLength;
        }

        internal void AddBytes(byte[] bytes)
        {
            Array.Copy(bytes, 0, Buffer, CurrentLength, bytes.Length);
            CurrentLength += bytes.Length;
        }
    }
}
