﻿using System;
using System.Collections.Generic;
using WingRtmpService.EmbeddedRtmpServer.Messaging.Events;

namespace WingRtmpService.EmbeddedRtmpServer.Net
{
    class VideoCacheGroup
    {
        private readonly List<VideoData> _cache = new List<VideoData>();

        public DateTime LastUpdateTime { get; private set; }

        public VideoData[] Cache
        {
            get
            {
                lock (_cache)
                {
                    return _cache.ToArray();
                }
            }
        }

        public void Add(VideoData videoData)
        {
            lock (_cache)
            {
                _cache.Add(videoData);
                LastUpdateTime = DateTime.UtcNow;
            }
        }
    }
}
