﻿using System;
using System.Collections.Generic;
using System.Text;

namespace WingRtmpService
{
    class PushLiveInfoConfig
    {
        /// <summary>
        /// 品牌
        /// </summary>
        public string Brand { get; set; }

        /// <summary>
        /// 型号集合
        /// </summary>
        public ICollection<PushLiveModelInfoConfig> PushLiveModelConfigs { get; set; }

        public DateTime UpdateTime { get; set; }

        public PushLiveInfoConfig(string brand)
        {
            Brand = brand;
        }
    }
    class PushLiveModelInfoConfig
    {
        public bool Lock { get; }
        public string Id { get;  }
        /// <summary>
        /// 型号
        /// </summary>
        public string Model { get; set; }
        /// <summary>
        /// 推荐分辨率宽度
        /// </summary>
        public int RecommendWidth { get; set; }

        /// <summary>
        /// 推荐分辨率高度
        /// </summary>
        public int RecommendHeight { get; set; }

        public PushLiveModelInfoConfig(string id,string model,int recommendWidth,int recommendHeight, bool iLock)
        {
            Lock = iLock;
            Id = id;
            Model = model;
            RecommendWidth = recommendWidth;
            RecommendHeight = recommendHeight;
        }
    }

    public enum LiveProtocol
    {
        Rtmp,
        RTC,
        Rtsp
    }

    class PushLiveModel
    { 

        public string TerminalId { get;  }
        public string TerminalName { get;  }
        public bool IsMerge { get; set; }

        public LiveProtocol LiveProtocol { get; set; }

        public DateTime UpdateTime { get; set; }

        public PushLiveModel(string terminalId, string terminalName, bool isMerge, LiveProtocol liveProtocol)
        {
            TerminalId = terminalId;
            TerminalName = terminalName;
            IsMerge = isMerge;
            LiveProtocol = liveProtocol;
        }

    }

}
